Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package backend
  Definition Classes
    nsc
-  package jvm
  Definition Classes
    backend
-  package opt
  Definition Classes
    jvm
- BoxUnbox
- ByteCodeRepository
- BytecodeUtils
- CallGraph
- ClosureOptimizer
- CopyProp
- InlineInfoAttribute
- InlineInfoAttributePrototype
- Inliner
- InlinerHeuristics
- LabelNotLive
- LocalOpt
- LocalOptImpls
- RemovePair
- RemovePairDependency

c

scala.tools.nsc.backend.jvm.opt

# Inliner 

###

#### class Inliner[BT <: BTypes] extends AnyRef

Source
  Inliner.scala

Linear Supertypes
AnyRef, Any
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Inliner
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new Inliner(btypes: BT)

### Type Members

1.  sealed trait InlineLog extends AnyRef
2.  final case class InlineLogFail (request: InlineRequest, warning: CannotInlineWarning) extends InlineLog with Product with Serializable
3.  final case class InlineLogRollback (request: InlineRequest, warnings: List[CannotInlineWarning]) extends InlineLog with Product with Serializable
4.  final case class InlineLogSuccess (request: InlineRequest, sizeBefore: Int, sizeInlined: Int) extends InlineLog with Product with Serializable
5.  class UndoLog extends AnyRef

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Inliner[BT] to any2stringadd[Inliner[BT]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (Inliner[BT], B)
   Implicit
     This member is added by an implicit conversion from Inliner[BT] to ArrowAssoc[Inliner[BT]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  val NoUndoLogging: UndoLog
7.  def adaptPostRequestForMainCallsite(post: InlineRequest, mainCallsite: Callsite): List[InlineRequest]

   Given an InlineRequest(mainCallsite, post = List(postCallsite)), the postCallsite is a callsite in the method `mainCallsite.callee`.

   Given an InlineRequest(mainCallsite, post = List(postCallsite)), the postCallsite is a callsite in the method `mainCallsite.callee`. Once the mainCallsite is inlined into the target method (mainCallsite.callsiteMethod), we need to find the cloned callsite that corresponds to the postCallsite so we can inline that into the target method as well.

   However, it is possible that there is no cloned callsite at all that corresponds to the postCallsite, for example if the corresponding callsite already inlined. Example:

   def a() = 1 def b() = a() + 2 def c() = b() + 3 def d() = c() + 4

   We have the following callsite objects in the call graph:

   c1 = a() in b c2 = b() in c c3 = c() in d

   Assume we have the following inline request r = InlineRequest(c3, post = List(InlineRequest(c2, post = List(InlineRequest(c1, post = Nil)))))

   But before inlining r, assume a separate InlineRequest(c2, post = Nil) is inlined first. We get

   c1' = a() in c // added to the call graph c1.inlinedClones += (c1' at c2) // remember that c1' was created when inlining c2 ~c2~ // c2 is removed from the call graph

   If we now inline r, we first inline c3. We get

   c1 = a() in d // added to call graph c1'.inlinedClones += (c1 at c3) // remember that c1 was created when inlining c3 ~c3~

   Now we continue with the post-requests for r, i.e. c2.

   - we try to find the clone of c2 that was created when inlining c3 - but there is none. c2 was already inlined before
   - we continue with the post-request of c2: c1
     - we search for the callsite of c1 that was cloned when inlining c2, we find c1'
     - recursively we search for the callsite of c1' that was cloned when inlining c3, we find c1
     - so we create an inline request for c1
8.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
9.  val btypes: BT
10.  def canInlineCallsite(callsite: Callsite): Option[(CannotInlineWarning, List[AbstractInsnNode])]

    Check whether the body of the callee contains any instructions that prevent the callsite from being inlined.

    Check whether the body of the callee contains any instructions that prevent the callsite from being inlined. See also method `earlyCanInlineCheck`.

    The result of this check depends on changes to the callee method's body. For example, if the callee initially invokes a private method, it cannot be inlined into a different class. If the private method is inlined into the callee, inlining the callee becomes possible. Therefore we don't query it while traversing the call graph and selecting callsites to inline - it might rule out callsites that can be inlined just fine.

    Returns

    - `None` if the callsite can be inlined
    - `Some((message, Nil))` if there was an issue performing the access checks, for example because of a missing classfile
    - `Some((message, instructions))` if inlining `instructions` into the callsite method would cause an IllegalAccessError
11.  def classIsAccessible(accessed: BT.BType, from: BT.ClassBType): Either[OptimizerWarning, Boolean]

    Check if a type is accessible to some class, as defined in JVMS 5.4.4.

    Check if a type is accessible to some class, as defined in JVMS 5.4.4. (A1) C is public (A2) C and D are members of the same run-time package

12.  def clone(): AnyRef
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
13.  def earlyCanInlineCheck(callsite: Callsite): Option[CannotInlineWarning]

    Check whether an inlining can be performed.

    Check whether an inlining can be performed. This method performs tests that don't change even if the body of the callee is changed by the inliner / optimizer, so it can be used early (when looking at the call graph and collecting inline requests for the program).

    The tests that inspect the callee's instructions are implemented in method `canInlineBody`, which is queried when performing an inline.

    returns

      `Some(message)` if inlining cannot be performed, `None` otherwise

14.  def ensuring(cond: (Inliner[BT]) ⇒ Boolean, msg: ⇒ Any): Inliner[BT]
    Implicit
      This member is added by an implicit conversion from Inliner[BT] to Ensuring[Inliner[BT]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
15.  def ensuring(cond: (Inliner[BT]) ⇒ Boolean): Inliner[BT]
    Implicit
      This member is added by an implicit conversion from Inliner[BT] to Ensuring[Inliner[BT]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
16.  def ensuring(cond: Boolean, msg: ⇒ Any): Inliner[BT]
    Implicit
      This member is added by an implicit conversion from Inliner[BT] to Ensuring[Inliner[BT]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
17.  def ensuring(cond: Boolean): Inliner[BT]
    Implicit
      This member is added by an implicit conversion from Inliner[BT] to Ensuring[Inliner[BT]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
18.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
19.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
20.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
21.  def findIllegalAccess(instructions: InsnList, calleeDeclarationClass: BT.ClassBType, destinationClass: BT.ClassBType): Either[(AbstractInsnNode, OptimizerWarning), List[AbstractInsnNode]]

    Returns

    Returns

    - `Right(Nil)` if all instructions can be safely inlined
    - `Right(insns)` if inlining any of `insns` would cause a java.lang.IllegalAccessError when inlined into the `destinationClass`
    - `Left((insn, warning))` if validity of some instruction could not be checked because an error occurred
22.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from Inliner[BT] to StringFormat[Inliner[BT]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
23.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
24.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
25.  def inline(request: InlineRequest, undo: UndoLog = NoUndoLogging): List[CannotInlineWarning]

    Inline the callsite of an inlining request and its post-inlining requests.

    Inline the callsite of an inlining request and its post-inlining requests.

    returns

      An inliner warning for each callsite that could not be inlined.

26.  def inlineCallsite(callsite: Callsite, undo: UndoLog = NoUndoLogging): Unit

    Copy and adapt the instructions of a method to a callsite.

    Copy and adapt the instructions of a method to a callsite.

    Preconditions:

    - The callsite can safely be inlined (canInlineBody is true)
    - The maxLocals and maxStack values of the callsite method are correctly computed
    returns

      A map associating instruction nodes of the callee with the corresponding cloned instruction in the callsite method.

27.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
28.  def memberIsAccessible(memberFlags: Int, memberDeclClass: BT.ClassBType, memberRefClass: BT.ClassBType, from: BT.ClassBType): Either[OptimizerWarning, Boolean]

    Check if a member reference is accessible from the destinationClass, as defined in the JVMS 5.4.4.

    Check if a member reference is accessible from the destinationClass, as defined in the JVMS 5.4.4. Note that the class name in a field / method reference is not necessarily the class in which the member is declared:

    class A { def f = 0 }; class B extends A { f }

    The INVOKEVIRTUAL instruction uses a method reference "B.f ()I". Therefore this method has two parameters:

    memberDeclClass

      The class in which the member is declared (A)

    memberRefClass

      The class used in the member reference (B) (B0) JVMS 5.4.3.2 / 5.4.3.3: when resolving a member of class C in D, the class C is resolved first. According to 5.4.3.1, this requires C to be accessible in D. JVMS 5.4.4 summary: A field or method R is accessible to a class D (destinationClass) iff (B1) R is public (B2) R is protected, declared in C (memberDeclClass) and D is a subclass of C. If R is not static, R must contain a symbolic reference to a class T (memberRefClass), such that T is either a subclass of D, a superclass of D, or D itself. Also (P) needs to be satisfied. (B3) R is either protected or has default access and declared by a class in the same run-time package as D. If R is protected, also (P) needs to be satisfied. (B4) R is private and is declared in D. (P) When accessing a protected instance member, the target object on the stack (the receiver) has to be a subtype of D (destinationClass). This is enforced by classfile verification (https://docs.oracle.com/javase/specs/jvms/se8/html/jvms-4.html#jvms-4.10.1.8). TODO: we cannot currently implement (P) because we don't have the necessary information available. Once we have a type propagation analysis implemented, we can extract the receiver type from there (https://github.com/scala-opt/scala/issues/13).

29.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
30.  final def notify(): Unit
    Definition Classes
      AnyRef
31.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
32.  def runInliner(): Unit
33.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
34.  def toString(): String
    Definition Classes
      AnyRef → Any
35.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
36.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
37.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
38.  def →[B](y: B): (Inliner[BT], B)
    Implicit
      This member is added by an implicit conversion from Inliner[BT] to ArrowAssoc[Inliner[BT]] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc
39.  object InlineLog
40.  object callsiteOrdering extends Ordering[InlineRequest]

    Ordering for inline requests.

    Ordering for inline requests. Required to make the inliner deterministic:

    - Always remove the same request when breaking inlining cycles
    - Perform inlinings in a consistent order

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Inliner[BT] to any2stringadd[Inliner[BT]]

### Inherited by implicit conversion StringFormat from Inliner[BT] to StringFormat[Inliner[BT]]

### Inherited by implicit conversion Ensuring from Inliner[BT] to Ensuring[Inliner[BT]]

### Inherited by implicit conversion ArrowAssoc from Inliner[BT] to ArrowAssoc[Inliner[BT]]

### Ungrouped